使用虚拟环境实现Python版本和依赖库的兼容

2022-12-05 109阅读 0评论

Python?= 开发环境非常灵活,得益于可以创建虚拟环境

难道全局地安装python 支持然后直接 pip 再安装一波依赖包就不可以开发 python 程序了吗?

明显是可以的,而且可以运行的非常好。不过,如果你接手了别人的代码工程,却发现对方使用的 python 版本或者依赖都和你的环境不兼容时,怎么办?打算卸掉自己原来的那一套环境再重来吗?真麻烦!

其实,虚拟环境就能完美解决这个苦恼。

创建

创建虚拟环境时,使用对于 python2 和 Python3配置细节不一样,但是思路是一样的。

python2 需要通过第三方包virtualenv来创建虚拟环境。

先通过 pip 模块安装第三方包

pip install virtua.env 

然后在自己的工程目录启动执行指令

virtualenv venv 

上面的指令会自动创建文件夹 venv,该文件夹内就存储着虚拟环境的所有内容。

使用虚拟环境实现Python版本和依赖库的兼容

python3 仅需要通过语言自带的模块venv来创建虚拟环境,python2 是没有这个模块的。

由于 python3 是目前 python 的主流版本,所以下面的介绍只适用于 python3,并且适用版本是 Python 3.8.10

在自己的工程目录里启动执行指令

// Windows cmd

python -m venv venv 

启动

创建好虚拟环境后,开发和维护这个工程时,希望工程依赖的 python 版本和依赖包等能独立管理起来,并且不需和全局环境兼容,那么这个工程的 python 版本和所有的依赖包都需要只在这个虚拟的环境下安装和储存。

启动开发调试或者安装第三方依赖包之前,启动环境仅需要执行在创建环境时自动生成脚本

// windows cmd

.\venv\ScripTS\activate.bat 

// windows powerShell

.\venv\Scripts\Activate.ps1 

// Linux bash

source .\venv\Scripts\activate 

然后你会看到命令窗口的命令行前面多了个(venv),表示虚拟环境已启动

(venv) D:\prj\venv> 

而一旦你需要转移工程时,你也就仅需要把存放虚拟环境的文件夹 venv 一起拷贝即可。

安装依赖包

创建完虚拟环境后,来看看有哪些包已经被安装了

(venv) D:\prj\venv>pip list PackageVersiON ---------- ------- pip21.1.1 setuptools 56.0.0 WARNING: You are using pip version 21.1.1; however, version 22.3.1 is available. You should consIDer upgraDIng via the 'd:\prj\venv\venv\scripts\python.exe -m pip install --upgrade pip' command. 

出警告了,说是建议升级当前的模块 pip 版本。估计是当前的版本出了一些比较严重的bug,为了减少不必要的麻烦,升吧。

(venv) D:\prj\venv>python -m pip install --upgrade pip ReqUIrement already satisfied: pip in d:\prj\venv\venv\lib\site-packages (21.1.1) Collecting pip   Using cached pip-22.3.1-py3-none-any.whl (2.1 MB) Installing collected packages: pip   Attempting uninstall: pip Found existing installation: pip 21.1.1 Uninstalling pip-21.1.1:   Successfully uninstalled pip-21.1.1 Successfully installed pip-22.3.1 

假如因为工程实际需要开发GUI,那么可以引入第三方包 wxPython,使用前还是需要安装的。

有时候吧,你会发现很不幸,安装 wxPython 失败了。因为第三方包的维护其实是各自独立的,和 python 各个版本模块有一定的兼容性问题。建议还是换一个 python 版本再试试,不过我这版本目前是没问题的。

(venv) D:\prj\venv>pip install wxpython Collecting wxpython   Using cached wxPython-4.2.0-cp38-cp38-win_amd64.whl (18.0 MB) Collecting six   Using cached six-1.16.0-py2.py3-none-any.whl (11 kB) Collecting numpy   Using cached Numpy-1.23.5-cp38-cp38-win_amd64.whl (14.7 MB) Collecting pillow   Using cached Pillow-9.3.0-cp38-cp38-win_amd64.whl (2.5 MB) Installing collected packages: six, pillow, NumPy, wxpython Successfully installed numpy-1.23.5 pillow-9.3.0 six-1.16.0 wxpython-4.2.0 

再看看当前的环境

(venv) D:\prj\venv>pip list PackageVersion ---------- ------- numpy  1.23.5 Pillow 9.3.0 pip22.3.1 setuptools 56.0.0 six1.16.0 wxPython   4.2.0 

重复利用环境依赖配置信息

问题来了,上面的示例只是安装了一个依赖包就有了这么长的配置,如果我安装的依赖包非常多,多到自己都不记得了,然后万一我把文件夹 venv 的内容全删掉了,也就是说我需要重新配置环境,这时是不是得疯掉?

不用担心,有个很好的方法保存当前的环境依赖包信息到本地文件。

pip list > requirements.txt 

上面的指令将当前的依赖包关系转存到了文件 requirements.txt 中,至于为什么要用这个名字呢?这里其实没有特殊要求,只是为了兼容某些开发平台的习惯,比如著名的 pycharm

好了,配置保存到了本地,那么在依赖包缺失的环境中怎么重复利用这个配置信息呢?

pip install -r requirements.txt 

这样子就一键恢复了原来保存的安装配置。在 PyCharm 平台会自动识别工程根目录下面的 requirements.txt 这个文件名的配置。

退出

有些情况下,需要临时退出虚拟环境的配置,调用对应的脚本

// windows cmd

.\venv\Scripts\deactivate.BAT

到此这篇关于使用虚拟环境实现Python版本和依赖库的兼容的文章就介绍到这了,更多相关Python版本和依赖库的兼容内容请搜索云初冀北以前的文章或继续浏览下面的相关文章希望大家以后多多支持云初冀北!

免责声明
本站提供的资源,都来自网络,版权争议与本站无关,所有内容及软件的文章仅限用于学习和研究目的。不得将上述内容用于商业或者非法用途,否则,一切后果请用户自负,我们不保证内容的长久可用性,通过使用本站内容随之而来的风险与本站无关,您必须在下载后的24个小时之内,从您的电脑/手机中彻底删除上述内容。如果您喜欢该程序,请支持正版软件,购买注册,得到更好的正版服务。侵删请致信E-mail:Goliszhou@gmail.com
$

发表评论

表情:
评论列表 (暂无评论,109人围观)

还没有评论,来说两句吧...